﻿Public Class Form1
    Dim glDevice As Long = -1
    Dim m_pgsi As New PGSDK_Class.PGSI

    Private Sub BnGetHW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BnGetHW.Click
        Dim i, ID As Long
        Dim szModel As String
        If PGSDK_Class.upgInitEx(0, 0) Then
            i = PGSDK_Class.upgGetStatus()
            ID = i And 255
            glDevice = i >> 16
            If ID <= 0 Then
                If glDevice <> -1 Then
                    PGSDK_Class.upgShutdown()
                    glDevice = -1
                End If
            End If
            If (glDevice = -1) Then
                MessageBox.Show(Me, "No Hardware!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return
            End If
            If (ID = &H10) Then
                szModel = "PKPG2116+ (512K)"
            ElseIf (ID = &H6) Then
                szModel = "PG2050 (512K)"
            Else
                szModel = "Other Models"
            End If
            TextBox1.Text = szModel
            BnGetHW.Enabled = False
            BnStart.Enabled = True
            BnStop.Enabled = True
            BnShutdown.Enabled = True
        End If
    End Sub

    Private Sub BnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BnStart.Click
        Dim lResult As Long
        Dim lRet As Long
        Dim lFileType As Long
        Dim Str, Str1, Str2 As String

        Str = TextBox2.Text
        Str1 = Str.Substring(Str.Length() - 4)
        Str2 = Str1.ToUpper()
        If (StrComp(Str2, ".PGW") = 0) Then
            lFileType = 0
        ElseIf (StrComp(Str2, ".PGV") = 0) Then
            lFileType = 1
        Else
            MessageBox.Show(Me, "Unknown file type!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        End If
        PGSDK_Class.upgAdjVolt(0, 5000)
        PGSDK_Class.upgAdjVolt(1, 5000)
        m_pgsi.iPodVolt(0) = 5000
        m_pgsi.iPodVolt(1) = 5000

        lResult = PGSDK_Class.upgStart(Str, lFileType, m_pgsi)
        lRet = (lResult And &HFFFF)
        If (lRet = 0) Then
            BnBrowse.Enabled = False
            BnStart.Enabled = False
        ElseIf (lRet = 1) Then
            MessageBox.Show(Me, "File Not Found.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 2) Then
            MessageBox.Show(Me, "File Reading Error.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 3) Then
            MessageBox.Show(Me, "File Type Error or Not Support.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 4) Then
            MessageBox.Show(Me, "File Format Error.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 5) Then
            MessageBox.Show(Me, "File Version is too old.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 6) Then
            MessageBox.Show(Me, "Memory Not Enough.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 7) Then
            MessageBox.Show(Me, "Singal Name confuse in PGV file.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 8) Then
            MessageBox.Show(Me, "Too many channel to be defined.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 9) Then
            MessageBox.Show(Me, "PGV Time Stamp Error.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 10) Then
            MessageBox.Show(Me, "Can't use Time Stamp and INTERVAL or FREQUENCY at same time.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 11) Then
            MessageBox.Show(Me, "No Signal Name in PGV File.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 12) Then
            MessageBox.Show(Me, "Over PG hardware memory depth.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 13) Then
            MessageBox.Show(Me, "No Time Stamp in Time Stamp mode.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 14) Then
            MessageBox.Show(Me, "No channel assigned for some signal.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = 99) Then
            MessageBox.Show(Me, "No Hardware.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf (lRet = &H8001) Then
            Dim result As Integer = MessageBox.Show(Me, "Warning: Use close frequency for system clock. Run(Y/N)", "", MessageBoxButtons.YesNo, MessageBoxIcon.Warning)
            If result = DialogResult.Yes Then
                BnBrowse.Enabled = False
                BnStart.Enabled = False
            Else
                PGSDK_Class.upgStop()
            End If
        Else
            MessageBox.Show(Me, "Critical Error.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub BnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BnStop.Click
        PGSDK_Class.upgStop()
        BnBrowse.Enabled = True
        BnStart.Enabled = True
    End Sub

    Private Sub BnShutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BnShutdown.Click
        BnStop_Click(sender, e)
        PGSDK_Class.upgShutdown()
        BnGetHW.Enabled = True
        BnStart.Enabled = False
        BnStop.Enabled = False
        BnShutdown.Enabled = False
        TextBox1.Text = ""
        glDevice = -1
    End Sub

    Private Sub BnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BnBrowse.Click
        Dim fd As OpenFileDialog = New OpenFileDialog()
        fd.Title = "Open PG file..."
        fd.InitialDirectory = "C:\"
        fd.Filter = "PG Waveform Files(*.pgw;*.pgv)|*.pgw;*.pgv|All Files(*.*)|*.*||"
        fd.FilterIndex = 1
        fd.RestoreDirectory = True

        If fd.ShowDialog() = DialogResult.OK Then
            TextBox2.Text = fd.FileName
        End If

    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_pgsi.Initialize()
    End Sub

End Class
